    Program c06gcfe

!     C06GCF Example Program Text

!     Mark 24 Release. NAG Copyright 2012.

!     .. Use Statements ..
      Use nag_library, Only: c06ecf, c06gcf, nag_wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: nin = 5, nout = 6
!     .. Local Scalars ..
      Integer                          :: ieof, ifail, j, n
!     .. Local Arrays ..
      Real (Kind=nag_wp), Allocatable  :: x(:), y(:)
!     .. Executable Statements ..
      Write (nout,*) 'C06GCF Example Program Results'
!     Skip heading in data file
      Read (nin,*)
loop: Do
        Read (nin,*,Iostat=ieof) n
        If (ieof<0) Exit loop

        Allocate (x(0:n-1),y(0:n-1))
        Read (nin,*)(x(j),y(j),j=0,n-1)

!       ifail: behaviour on error exit   
!              =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
        ifail = 0
        Call c06gcf(y,n,ifail)

        Call c06ecf(x,y,n,ifail)
        Call c06gcf(y,n,ifail)

        Write (nout,*)
        Write (nout,*) 'Components of inverse discrete Fourier transform'
        Write (nout,*)
        Write (nout,*) '           Real      Imag'
        Write (nout,*)
        Write (nout,99999)(j,x(j),y(j),j=0,n-1)
        Deallocate (x,y)
      End Do loop

99999 Format (1X,I6,2F10.5)
    End Program c06gcfe
